function pose_estimator()
clear;
close all;

addpath 'voc-release4.01';

%Define number of components/poses
nc = 4;
%Load model
load(['../models/epfl_car_' num2str(nc) ]);

%Read image
image_path = '../images/car1.jpg';
im = imread(image_path);

%Visualize the image?
%imshow(im);

%Visualize the model?
%visualizemodel(model);

disp('Processing image ...');
%Run detector

% lower threshold to get high recall?
model.thresh = min(0.5, model.thresh);

[dets, boxes] = imgdetect(im, model, model.thresh);

if ~isempty(boxes)
    %Reduce boxes
    boxes = reduceboxes(model, boxes);
    %Clip boxes
    [dets boxes] = clipboxes(im, dets, boxes);    
    %Non-maximal supression
    nms_overlap = 0.5;
    
    top_index = nms(dets, nms_overlap);
    
    %read bounding boxes
    bb = dets(top_index,[1:4]);
    %scores
    sc = dets(top_index,end);
    %poses
    pose = dets(top_index,5);
    
    
    %Visualize detections?
    showdetections(im,bb,pose,nc);
    
    
else
    disp('No detections :(');
end
